local my_dialog = nil

-- generic handler which accepts an optional parameter

local function closer(d)    
 
     if d and d.visible then
       d:close()
     end
end


----------------------------------------------------------------------
--preferences
----------------------------------------------------------------------

local options = renoise.Document.create {
  no_of_tick_rows = 17, large_keyboard = 1
}
renoise.tool().preferences = options


---------------------------------------------------------------------------------------------------
--Main()
---------------------------------------------------------------------------------------------------
 

function render_notes()

 
  local number_of_ticky_rows = options.no_of_tick_rows.value
  local first_c = 25
  local top_c =  91
  
  local l_keyboard = options.large_keyboard.value
  
  if l_keyboard == 2 then
    first_c = 1
    top_c = 120
  end

--functions()

--set all velocities
  local function set_all_velocities(pattern_index,track_index,my_vol)
  
  local pattern_iter = renoise.song().pattern_iterator
 
   for pos,line in   pattern_iter:note_columns_in_pattern_track(pattern_index,track_index,my_vol) do                     
   
     if line.note_value ~= 120  then 
       if line.note_value ~= 121  then
     
        if my_vol == 128 then
           line.volume_value = 255
             else  line.volume_value = my_vol
        end                
      end
     end
                        
   end
  end
             
--Iterator Get Notes
  local function iterator_get_notes(number_of_ticky_rows,pattern_index,track_index,chosen_line_range,iteration,
  iter_incrementor,pattern_iter,shrink_mode)
    
    
    if shrink_mode then --iterator
   
    local pattern_iter = renoise.song().pattern_iterator
    
    for row = 1,number_of_ticky_rows do
 
          iter_incrementor = 1 --reset iter inc for each row
       
       for pos,line in pattern_iter:note_columns_in_pattern_track(pattern_index,track_index) do
             
           
          if pos.line > chosen_line_range[row] then         
            break 
          end
         
          if pos.line == chosen_line_range[row] then        
            iteration[row].present_notes[iter_incrementor] = line.note_value
            iter_incrementor = iter_incrementor +1
          end   
       end     
    
    end
    
    
    else --not shrink_mode i.e Normal mode--> :line(line_index) method
    
    local pattern_track = renoise.song().patterns[pattern_index].tracks[track_index]
    local range_start = chosen_line_range[1]
    local range_end = chosen_line_range[1] + (number_of_ticky_rows - 1)
    local iter_incrementor_1 = 1
  
    for line_index = range_start,range_end do
      local note_columns = pattern_track:line(line_index).note_columns
    
      for column_index  = 1,12 do
        iteration[iter_incrementor_1].present_notes[column_index] = note_columns[column_index].note_value        
      end
    
      iter_incrementor_1 = iter_incrementor_1 + 1
    end
  
   end-- if shrink_mode end
end 
   
--Fill row note tables .
  local  function my_fill_pattern_notes_table(pattern_notes,iteration,number_of_ticky_rows,first_c)  --needs to cover all rows
      
    for row = 1,number_of_ticky_rows do  
      
     --all to false      
      for i = 1,121 do --fill with 121 falses
          pattern_notes[row].row_notes[i] = false
      end
   
       --add trues
      for i = 1,12 do
       pattern_notes[row].row_notes[(iteration[row].present_notes[i])+1] = true 
      end     
    end
  end
  

--update checkboxes 
  local  function update_checkboxes(number_of_ticky_rows,first_c,top_c,refresh_happening,pattern_notes,vb )
                  
          --reset vb:views checkbox id`s
           for row = 1,number_of_ticky_rows do
   
             for i  = first_c,top_c do
                
               refresh_happening = true --stops checkbox notifier re-firing
               vb.views[row.."cb_"..i].value = pattern_notes[row].row_notes[i]
               refresh_happening = false --then reset
             
             end       
           end  
    end
    
 ---------------------------------------------------------------------------------------------------

 local function shrink_fn(vb,pattern_index,chosen_line_range,number_of_ticky_rows,pattern_length,track) 
                  
                  
   vb.views["Change_ran"].value = 0  --reset range valuebox
   local inc = 1
   local inc_2 = 0
                  
   pattern_length = renoise.song().patterns[pattern_index].number_of_lines
   local last_noted_row = pattern_length
                 
                for row = 1,pattern_length do
               
                  local event_row = track.lines[row]
                  local note_here = false
                  
                
                  if event_row.is_empty == false then --row with some events
                                                           
                      for column = 1,12 do
                       note_here = false 
                        if event_row.note_columns[column].note_value ~= 120 then --off
                          if event_row.note_columns[column].note_value ~= 121 then  --empty
                            note_here = true
                            last_noted_row = row + 1
                            break                         
                          end
                        end                                                                
                      end
                  
                  end
                     if note_here  then 
                       chosen_line_range[inc] = row --add to table
                       vb.views["row_num"..inc].value = row -1--reset row valueboxes
                       inc = inc + 1
                     end
                 
                                             
                    if (inc - 1) == number_of_ticky_rows then
                     break
                    end 
        
                    if row == pattern_length then
        
                -- number_of_ticky_rows = inc ---alternative way
                      for i = inc, number_of_ticky_rows do
                       
                         chosen_line_range[i] = pattern_length-- (last_noted_row + inc_2) 
                         vb.views["row_num"..i].value = pattern_length - 1--(last_noted_row + inc_2)-- reset row valueboxes
                         inc_2 = inc_2 + 1 
                             
                      end
                      
                    end 
                    
                  end
                  
 end --shrink fn-------------------------------------------------------------------

 local function reset_boxes(number_of_ticky_rows,vb,chosen_line_range,line_index_holder)
                      
                      for i = 1,number_of_ticky_rows do --reset row vbs
                         vb.views["row_num"..i].value = (i-1)  
                      end
                        
                      vb.views["Change_ran"].value = 0 --reset rangestart vb
                      chosen_line_range = {}                                             
                         
                      for row = 1,number_of_ticky_rows do                          
                        chosen_line_range[row] =  row   --Lua starts at 1
                      end
                      --------------------------
  
                      line_index_holder =  chosen_line_range[1]   
                                
                      end
                      
                      
------------------------------------------------------------------------------------------------


  local   function focus_pattern()
            renoise.app().window.lock_keyboard_focus = false
            renoise.app().window.lock_keyboard_focus = true
          end  
  
   
  
     local note_strings = {
    
    
     
    "0\nC", "\n#", "\nD", "\n#", "\nE", "\nF", 
    "\n#", "\nG", "\n#", "\nA", "\n#", "\nB",
    
    "1\nC", "\n#", "\nD", "\n#", "\nE", "\nF", 
    "\n#", "\nG", "\n#", "\nA", "\n#", "\nB",
    
    "2\nC", "\n#", "\nD", "\n#", "\nE", "\nF", 
    "\n#", "\nG", "\n#", "\nA", "\n#", "\nB",
    
    "3\nC", "\n#", "\nD", "\n#", "\nE", "\nF", 
    "\n#", "\nG", "\n#", "\nA", "\n#", "\nB",
    
    "4\nC", "\n#", "\nD", "\n#", "\nE", "\nF", 
    "\n#", "\nG", "\n#", "\nA", "\n#", "\nB",
    
    "M\nC", "\n#", "\nD", "\n#", "\nE", "\nF", 
    "\n#", "\nG", "\n#", "\nA", "\n#", "\nB",
    
    "6\nC", "\n#", "\nD", "\n#", "\nE", "\nF", 
    "\n#", "\nG", "\n#", "\nA", "\n#", "\nB",
    
    "7\nC", "\n#", "\nD", "\n#", "\nE", "\nF", 
    "\n#", "\nG", "\n#", "\nA", "\n#", "\nB",
    
    "8\nC", "\n#", "\nD", "\n#", "\nE", "\nF", 
    "\n#", "\nG", "\n#", "\nA", "\n#", "\nB",
    
    "9\nC", "\n#", "\nD", "\n#", "\nE", "\nF", 
    "\n#", "\nG", "\n#", "\nA", "\n#", "\nB",
    
     }
  
    
  local refresh_happening = false
  local refresh_ui = false
  
  local shrink_mode = false
  
  
  local my_vol = 128 
    
  local current_line = 1
  local current_line_2 = 1
  local iter_incrementor = 1
  
   
   
                  
    

  --change to change shown rows
  local pattern_iter = renoise.song().pattern_iterator
  local pattern_index =  renoise.song().selected_pattern_index
  local track_index = renoise.song().selected_track_index
  local line_index = renoise.song().selected_line_index
   
  local track_index_holder = track_index    
  local line_index_holder = line_index
  local pattern_index_holder = pattern_index
   
  local pattern_length = renoise.song().patterns[pattern_index].number_of_lines -- in pattern
    
  
    
    if number_of_ticky_rows > pattern_length - (line_index - 1) then --towards end of pattern, limit ticky rows
     number_of_ticky_rows = pattern_length - (line_index - 1)
    end  
    
    
------------------------------------------------------------------------------------    
    
  local chosen_line_range = {}
  
  for i = 1,number_of_ticky_rows do 
   chosen_line_range[i] = i
  end
  
  local reset_to_normal_mode = false
  local condensed_mode = false
  local line_index = renoise.song().selected_line_index 
  local track = renoise.song().patterns[pattern_index].tracks[track_index]
    
  --------------------------------------------------------------------------- 
  
      --chosen_line_range[1] == FIRST CHOSEN ROW
  for row = 1,number_of_ticky_rows do
    chosen_line_range[row] =  line_index_holder + (row - 1)  --Lua starts at 1
  end
    
   
    
     
     
   
 -------------------------------------------------------------------  
   
  local pattern_notes = {}
  local iteration = {}
    
    
    
  
    --declare note sub-tables
    for row = 1, number_of_ticky_rows do 
      pattern_notes[row] = {}  --
      pattern_notes[row].row_notes = {}
    end
    
    --declare iteration sub-tables
    for row = 1, number_of_ticky_rows do  
      iteration[row] = {}  
      iteration[row].present_notes = {}
    end
     
    
    
    
    
      
----------------------------------------------------------------------------------------     
    --Get Velocity From First note in track
                          
 for pos,line in pattern_iter:note_columns_in_pattern_track(pattern_index,track_index) do
          
  my_vol = 128 
  
   if line.note_value ~= 121 then --empty
     if line.note_value ~= 120 then --off 
   
       if line.volume_value ~= 255 then         
         my_vol = (line.volume_value)
          break
       else my_vol = 128  
         break
       end            
     end  
   end
 end     
    
    
    
         

---------------------------------------------------------------------------------------------------
-- 1. Initial Get Notes From Track 
---------------------------------------------------------------------------------------------------

  
  --iterate 
  
  iterator_get_notes(number_of_ticky_rows,pattern_index,track_index,chosen_line_range,iteration,
  iter_incrementor,pattern_iter,shrink_mode)
-- iterator_get_notes(number_of_ticky_rows,pattern_index,track_index,
-- chosen_line_range,iteration,iter_incrementor,pattern_iter)--  
 my_fill_pattern_notes_table(pattern_notes,iteration,number_of_ticky_rows)--           
 ---------------------------------------------------------------------

 ---------------------------------------------------------------------------------
-- GUI
 ----------------------------------------------------------------------------------
  
   local vb = renoise.ViewBuilder()
   local CONTENT_SPACING = renoise.ViewBuilder.DEFAULT_CONTROL_SPACING
  
   local all_checkbox_rows = vb:column {}-- change for orientation (1) line 296 also
   local pitch_labels = vb:row {}
   local pitch_labels_2 = vb:row {} 
   local play = vb:row {} 
   local stop = vb:row {}
   local solo = vb:row {}
   local focus = vb:row {}
  -- local user_rows = vb:row {}
  --  local user_size = vb:row {} 
   local velocity_val = vb:row {}
   local velocity_set = vb:row {} 
   local change_range = vb:row {}
   local view_con_pattern = vb:row {}
  
   
  
   
 --User choose start row 
   local range_vb = vb:valuebox {
                   min = 0,
                   max = pattern_length - number_of_ticky_rows,
                   value = line_index_holder - 1,
                   id = "Change_ran" ,
                     
                     notifier = function(number)
                         
                        if not shrink_mode then
                         
                         chosen_line_range = {}                                             
                         
                        
                      -- if number > pattern_length - number_of_ticky_rows then
                     --    number = pattern_length - number_of_ticky_rows
                     --  end
                         
                         for row = 1,number_of_ticky_rows do                          
                           chosen_line_range[row] =  number + (row )  --Lua starts at 1
                           vb.views["row_num"..row].value = chosen_line_range[row] - 1 --reset row cbs
                         end
                         --------------------------
                         
                         
                      
                       
  
                         line_index_holder =  chosen_line_range[1]   
                                
                           
                     --REFRESH
                           
                     --iterate 
                    iterator_get_notes(number_of_ticky_rows,pattern_index,track_index,chosen_line_range,iteration,
                    iter_incrementor,pattern_iter,shrink_mode)--  
                     my_fill_pattern_notes_table(pattern_notes,iteration,number_of_ticky_rows)--           
                     ---------------------------------------------------------------------
                      
                     for row = 1,number_of_ticky_rows do  
   
                       for i  = first_c,top_c do
                         refresh_happening = true
                         vb.views[row.."cb_"..i].value = pattern_notes[row].row_notes[i]
                       end
                     refresh_happening = false
                      
                     end  
                       
                       else 
                        vb.views["Change_ran"].value = 0 --i.e shrink = true
                        renoise.app():show_status("Only Available In Normal Mode")
                        return
                      end
                  --focus pattern_editor                
                  focus_pattern()
                
               
                 
             
                 end 
                     
                      
                     
                      }
                
                 change_range:add_child(range_vb)
     

--user set velocity readout



--User set velocity
   local vel_vb = vb:rotary {
                    
                   min = 0,
                   max = 127,
                   value = my_vol -1, 
                     
                     notifier = function(number,value)
                       my_vol = number + 1 
                       
                      -- print(("rotaty encoder value changed to '%.1f'"):
                      -- format(number))
                       end
                      }
                
                 velocity_val:add_child(vel_vb)
                 
--local velocity_set_readout = vb:row {vb:text{}}








--user set all

 local vel_set = vb:button {
                   text = "Set All",
                   notifier = function(number)
                       
                     
                      set_all_velocities(pattern_index,track_index,my_vol)
                     
                     
                     end
                      }
                
                 velocity_set:add_child(vel_set)


local shrink = vb:switch {
                  -- text = "Shrink",
                  items = { "Normal","Shrink"},
                  width = 85,
                   id = "shrink_button",
                   value = 1,
                   notifier = function(value)
                   
                   if not reset_to_normal_mode then
                    line_index_holder =  1
                       
                   if value == 2 then                     
                     shrink_mode = true
                     shrink_fn(vb,pattern_index,chosen_line_range,number_of_ticky_rows,pattern_length,track)
                   
                   else shrink_mode = false
                   reset_boxes(number_of_ticky_rows,vb,chosen_line_range,line_index_holder)
                   end    
                     --REFRESH     
                     --iterate 
                     iterator_get_notes(number_of_ticky_rows,pattern_index,track_index,chosen_line_range,iteration,
                     iter_incrementor,pattern_iter,shrink_mode)--
                       
                     my_fill_pattern_notes_table(pattern_notes,iteration,number_of_ticky_rows)--           
                     ---------------------------------------------------------------------
                       
                       for row = 1,number_of_ticky_rows do  
                         for i  = first_c,top_c do
                         refresh_happening = true
                           vb.views[row.."cb_"..i].value = pattern_notes[row].row_notes[i]
                           
                         end
                        refresh_happening = false
                       end  
                     
             
                    --focus pattern_editor
                    focus_pattern()
                    
                       else reset_to_normal_mode = false
                      end
                      
                    end
                   }  
                
                 view_con_pattern:add_child(shrink)

     


--RESET BUTTON



 local reset_button = vb:button {
                   
                   text = "Reset",
                    
                      notifier = function()
                      
                      shrink_mode = false
                      vb.views["shrink_button"].value = 1 --turn off shrink mode  
                    
                      
                      reset_boxes(number_of_ticky_rows,vb,chosen_line_range,line_index_holder)    
                      
                      
                      --REFRESH
                           
                      --iterate 
                      iterator_get_notes(number_of_ticky_rows,pattern_index,track_index,chosen_line_range,iteration,
                      iter_incrementor,pattern_iter,shrink_mode)--  
                      my_fill_pattern_notes_table(pattern_notes,iteration,number_of_ticky_rows)--           
                     ---------------------------------------------------------------------
     
                      for row = 1,number_of_ticky_rows do  
   
                        for i  = first_c,top_c do
                        refresh_happening = true
                          vb.views[row.."cb_"..i].value = pattern_notes[row].row_notes[i]
                        end
                      refresh_happening = false
                      end  

                      --focus pattern_editor
                      focus_pattern()
                
                
                    --SECOND ITERATE REMOVED
                 
                
                 end 
                     
                      
                     
                      }
                                
     


 
 --  local close = vb:row {}

--[[  
 --User choose no .of rows  
   local user_vb = vb:valuebox {
                   min = 1,
                   max = 64,
                   value = number_of_ticky_rows, 
                     
                     notifier = function(number)
                       number_of_ticky_rows = number
                     end
                      }
                
                 user_rows:add_child(user_vb)
     
     
     --remem value
      local switch_value          
      if first_c == 25 then             
          switch_value = 1
          else
         switch_value = 2
      end
      
   local user_switch = vb:switch {
                       items = {"SML", "LRG"},
                       width = 100,
                       value = switch_value,
                     
                      notifier = function(index)
                       if index == 1 then 
                          first_c = 25
                          top_c =  92
                        elseif index == 2 then
                          first_c = 1
                          top_c = 120
                        
                       end
                     end
                      }
                
                 user_size:add_child(user_switch)
  --User choose size
   --]]
   
   
   
     
     
   --solo button
  
  local solo_button = vb:button {
                     text = " S ",
                      
                     notifier = function()
                       renoise.song().tracks[track_index_holder]:solo()
                     
                       --focus pattern_editor
                       renoise.app().window.lock_keyboard_focus = false
                       renoise.app().window.lock_keyboard_focus = true
                    end
                      }
                
                 solo:add_child(solo_button)
  

 
   --play button
  
  local play_button = vb:button {
                      text = "  PLAY  ",
                      
                      notifier = function()
                      renoise.app().window.lock_keyboard_focus = false
                        renoise.app().window.lock_keyboard_focus = true
                        renoise.song().transport:start_at(line_index_holder)
                        
                        --focus pattern_editor
                        
                      end
                      }
                 
                 play:add_child(play_button)
                 
    --stop button
  
  local stop_button = vb:button {
                      text = "  STOP  ",
                      
                      notifier = function()
                        renoise.song().transport:stop()
                        renoise.song().transport.playback_pos.line = line_index_holder
                        --focus pattern_editor
                        renoise.app().window.lock_keyboard_focus = false
                       renoise.app().window.lock_keyboard_focus = true
                      end
                      }
                 stop:add_child(stop_button)
                 
 
                 
                 

 
  for i = first_c,top_c do
       
       local note_txt = vb:text {
             text = note_strings[i],
             align = "center",
             width = "20%"
             
             }
             
       pitch_labels:add_child(note_txt)      
     
   end
   
     ------ Write note names for bottom row 
 
  for i = first_c,top_c do
       
       local note_txt = vb:text {
             text = note_strings[i],
             align = "center",
             width = "20%"
             
             }
             
       pitch_labels_2:add_child(note_txt)      
     
   end
   
   
 --number valueboxes  
   

 local all_row_numbers = vb:column {} 
 local ran_start = chosen_line_range[1] --holder
 
 for row = ran_start, chosen_line_range[number_of_ticky_rows]  do
  
   local individ_row_number = vb:row  {}
   local row_number_text  = vb:valuebox {  value = (row -1),
                                            max= 512,
                                            id = "row_num"..(row - ran_start + 1) ,
                                            
                                            notifier = function(number)
                                            chosen_line_range[row] = (number + 1)
                                            end
                                            
                                           
                                           }
                                           
                                           
    
    individ_row_number:add_child(row_number_text)
    all_row_numbers:add_child(individ_row_number) 
   
   end
  
  
   
   
   
   
   
   

---- create checkboxes for each row----
    
for row = 1,number_of_ticky_rows do
  
 local individ_checkbox_row = vb:row{ id = "row_id"..row} --Change for orientation (2)
 

------------------------------------------------------------------
    for i = first_c,top_c do   
    
   -- local note_not_present = not pattern_notes[row].row_notes[i]
    
       local note_button_2 = vb:checkbox {
             value = pattern_notes[row].row_notes[i],
             width = 18,
             id = row.."cb_"..i,             
             ---------------------------------------------------            
            
            
            
            
            
            
             notifier = function(state,id) --CHECKBOX NOTIFIER  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
            
             --focus pattern_editor
             focus_pattern()
             
             if not refresh_happening then                         
             
             ----------------------------------------------------------------------------------
             -- 1. Get Notes From Track 
             ----------------------------------------------------------------------------------

 
            --iterate 
                     iterator_get_notes(number_of_ticky_rows,pattern_index,track_index,chosen_line_range,iteration,
                     iter_incrementor,pattern_iter,shrink_mode)--  
                     my_fill_pattern_notes_table(pattern_notes,iteration,number_of_ticky_rows)--           
                     ---------------------------------------------------------------------

            ---------------------------------------------------------------------------------
   
             
    
    
             local inst_index = renoise.song().selected_instrument_index
 
             ----------------------------------------------------------------------------------
             --add and remove notes
             ----------------------------------------------------------------------------------
               
        
             if pattern_notes[row].row_notes[i] then --note to delete
 
             --iterate when unchecking box
              for pos,line in  pattern_iter:note_columns_in_pattern_track(pattern_index,track_index) do 
                    
                     if pos.line == chosen_line_range[row] then --current row
                       
                        if line.note_value == (i - 1) then
                          line.note_value = 121                          
                          line.instrument_value = 255
                          line.volume_value = 255 --empty
                         break
                        end
                     end
                     
                     
                    
                     if  pos.line > chosen_line_range[row] then
                       break
                     end
                                     
              end 
             
 
              --ITER DELETED
         
         
         
          else -- Add the note:
          
          --iter for + note i.e. checking box
            for pos,line in pattern_iter:note_columns_in_pattern_track(pattern_index,track_index) do
                   
                   
                   if  pos.line > chosen_line_range[row] then  --check for max 12 Notes reached             
                       renoise.app():show_status("Track Row Full: Only 12 Events Possible Per Row!")   
                         vb.views[row.."cb_"..i].value = false --reset current cbox to off
                          
                      break
                   end
                 
                  
                if pos.line == chosen_line_range[row] then
                   if line.note_value == 121 then
                      line.note_value = i-1
                     
                     if my_vol == 128 then line.volume_value = 255 else --i.e. no num
                      line.volume_value = my_vol
                      end
                      
                      
                      line.instrument_value = inst_index -1
                      
                       --expand track
                     if not 
                         renoise.song().patterns[pattern_index].tracks[track_index].lines[pos.line].note_columns[pos.column].is_empty then  --pos empty

                        if
                          renoise.song().tracks[track_index].visible_note_columns < pos.column then 
                          renoise.song().tracks[track_index].visible_note_columns = pos.column 
                        end
                     end
   
                    break
                   end 
                end 
                

                
                
            end
            
           end
          end 
        
        --deleted iter
     

      
      end, -- of notifier function 
    }
           
       individ_checkbox_row:add_child(note_button_2) --buttons
            
   
    end -- of "create checkboxes" for

---------------------------------------------------------------------------     
 all_checkbox_rows:add_child(individ_checkbox_row) --rows

end --GUI



  --Refresh button
   local refresh_button = vb:column {}
  
  
   local title =  vb:button { text = "REFRESH!",
            
                  notifier = function()--------------------------------------
                   
                   if shrink_mode then 
                    shrink_fn(vb,pattern_index,chosen_line_range,number_of_ticky_rows,pattern_length,track)
                   end
                 
                 --iterate 
                     iterator_get_notes(number_of_ticky_rows,pattern_index,track_index,chosen_line_range,iteration,
                     iter_incrementor,pattern_iter,shrink_mode)--  
                     my_fill_pattern_notes_table(pattern_notes,iteration,number_of_ticky_rows)--           
                     ---------------------------------------------------------------------
               
              --   local function set_cboxes(number_of_ticky_rows,first_c,top_c,refresh_happening,pattern_notes)
                  for row = 1,number_of_ticky_rows do
   
                    for i  = first_c,top_c do
                    refresh_happening = true
                      vb.views[row.."cb_"..i].value = pattern_notes[row].row_notes[i]
                    end
                   refresh_happening = false
                  end  
                  
               --  end                 
                -- set_cboxes(number_of_ticky_rows,first_c,top_c,refresh_happening,pattern_notes)
                 --focus pattern_editor
                 focus_pattern()
                 end  
                 }
                 --------------------------------------------------------------

 refresh_button:add_child(title)
 
--------------------------------------------------------------------------------- 
--Preferences GUI
---------------------------------------------------------------------------------
local prefs_dialog = nil

local full_chosen = options.large_keyboard.value
local rows_chosen = options.no_of_tick_rows.value

local prefs_button = vb:button {
                      text = "Prefs",
                     

                    notifier = function()
                      
                     local prefs_dialog_content = vb:column {
                                                  margin = 4 ,
                     
                                                  vb:column {
                                                   margin = 4,
                                                   style = "group",
                                                   
                                                    vb:row {
                                                    margin = 2,
                                                     
                                                     vb:text { 
                                                     text = "No. Of Rows      "
                                                     },
                                                     
                                                    --Number of Ticky Rows 
                                                    vb:valuebox {
                                                     min = 1,
                                                     max = 64,
                                                     value = number_of_ticky_rows,
                                                     
                                                     notifier = function(number)
                                                       rows_chosen = number  
                                                     end,
                                                     }, --valbox
                                                    },--row
                                                    
                                                     vb:row {
                                                    margin = 2,
                                                     
                                                     vb:text { 
                                                     text = "Ticky Width         "
                                                     },
                                                    --Large or small keyboard
                                                      vb:switch {
                                                       items = {"Small","Full"},
                                                       width = 90,
                                                       value = options.large_keyboard.value,
                                                       notifier = function(number)
                                                         full_chosen = number
                                                       end
                                                      }--swi
                                                     }, --row
                                                     
                                                      vb:horizontal_aligner {
                                                      margin = 12,
                                                      mode = "center",
                                                      
                                                     -- vb:text { 
                                                     -- text = "Apply and Close "
                                                     -- },
                                                     
                                                     vb:button {
                                                     width = 100,
                                                     text = "Apply and Close",
                                                     
                                                     notifier = function()
                                                       options.large_keyboard.value = full_chosen 
                                                       options.no_of_tick_rows.value = rows_chosen
                                                      
                                                      if prefs_dialog and  prefs_dialog.visible then
                                                       prefs_dialog:close()
                                                      end
                                                      if my_dialog and my_dialog.visible then
                                                       my_dialog:close() 
                                                      end
                                                     end
                                                     
                                                     
                                                     }--button
                                                    },--row
                                                    
                                                    
                                                     vb:row {
                                                    margin = 2,
                                                     
                                                     vb:text { 
                                                     text = "To Cancel, Close Window With [X]",
                                                     font = "italic"
                                                     }--text
                                                    }--row
                                                   }
                                                  }  

                        prefs_dialog = renoise.app():show_custom_dialog("Preferences", prefs_dialog_content)
 
                     end,
 
                       }
 



 local function my_keyhandler_func(dialog, key)
       
         
      if (key.modifiers == "" and key.name == "esc") then
        
        dialog:close()
        
      end
      
      if key.name == "ralt" then
       renoise.song().transport:start_at(line_index_holder)
       key.repeated = false
      end
      
      if key.name == "space" then 
     -- renoise.song().transport:stop()
      end
      
     if  key.name ~=   "ralt" then 
       return key
      end
      
      
  end 





local lower_gui = vb:row {
                   vb:column {
                    vb:text {text = "\n"},
                     all_row_numbers
                    },
                    vb:column {
                     pitch_labels,
                     all_checkbox_rows,
                     pitch_labels_2
                    }
                   }

local right_buttons = vb:row {
                       vb:text {
                        text = "Velocity"
                        },
                       velocity_val,
                       velocity_set,
                      }
                       
local top_buttons = vb:horizontal_aligner {
                     mode = "justify",                     
                     prefs_button,
                     right_buttons
                    }
                     
                     
   
local centre_buttons = vb:horizontal_aligner {
                        mode = "center",
                        view_con_pattern,
                        reset_button,
                        change_range,
                        solo,
                        play,
                        stop,
                        refresh_button
                       }



 local dialog_content = vb:column {
                         margin = 2,
                         spacing = CONTENT_SPACING,                 
                         top_buttons ,
                         centre_buttons,         
                         lower_gui, 
                        }

  
 

  my_dialog = renoise.app():show_custom_dialog("Ticky Roll 0.54     |  ".."Pattern  "..(pattern_index-1).."  "..renoise.song().tracks[track_index].name, dialog_content,my_keyhandler_func)

--focus pattern_editor 
focus_pattern()



--Notifiers
---------------------------------------------------------------------------------------------------------------------------------------

 
  local function line_has_changed()
  refresh_ui = true
  
  end
 
  
  
  local function idle()
   
    if refresh_ui then
      
      refresh_ui = false
     -- refresh_happening = true
        
        if not shrink_mode then                     
              
         --iterate
         iterator_get_notes(number_of_ticky_rows,pattern_index,track_index,chosen_line_range,iteration,
         iter_incrementor,pattern_iter,shrink_mode)--  
         my_fill_pattern_notes_table(pattern_notes,iteration,number_of_ticky_rows)--           
         ---------------------------------------------------------------------

         --reset vb:views checkbox id`s
         for row = 1,number_of_ticky_rows do
                      
          -- vb.views["row_num"..row].value = chosen_line_range[row] - 1--reset row valueboxes
                      
           for i  = first_c,top_c do
                
             refresh_happening = true --stops checkbox notifier re-firing
             vb.views[row.."cb_"..i].value = pattern_notes[row].row_notes[i]                      
             refresh_happening = false --then reset
           end       
         end
      end 
    end 
end




 local function refresh_when_play()
                   
   if shrink_mode then 
                   
     shrink_fn(vb,pattern_index,chosen_line_range,number_of_ticky_rows,pattern_length,track)
     refresh_happening = false
                     
     --iterate
     iterator_get_notes(number_of_ticky_rows,pattern_index,track_index,chosen_line_range,iteration,
     iter_incrementor,pattern_iter,shrink_mode)--  
     my_fill_pattern_notes_table(pattern_notes,iteration,number_of_ticky_rows)--           
     ---------------------------------------------------------------------

     --reset vb:views checkbox id`s
     for row = 1,number_of_ticky_rows do
                      
       vb.views["row_num"..row].value = chosen_line_range[row] - 1--reset row valueboxes
                      
       for i  = first_c,top_c do
                
         refresh_happening = true --stops checkbox notifier re-firing
         vb.views[row.."cb_"..i].value = pattern_notes[row].row_notes[i]                      
         refresh_happening = false --then reset
       end       
     end
    end 
 end




------------------------------------------------------------------------------                  
-- remove notifiers                  
local function check_closed() 
  
 if  not my_dialog.visible  then
 renoise.song().transport.playing_observable:remove_notifier(refresh_when_play)
 renoise.song().transport.playing_observable:remove_notifier(check_closed)
 renoise.tool().app_idle_observable:remove_notifier(idle)
-- renoise.song().transport.playing_observable:remove_notifier(check_closed)
 renoise.song().patterns[pattern_index_holder]:remove_line_notifier(line_has_changed)
  
           
 end            
end
                 

--notifiers
renoise.song().transport.playing_observable:add_notifier(refresh_when_play)
renoise.tool().app_idle_observable:add_notifier(idle)
renoise.tool().app_release_document_observable:add_notifier(closer, my_dialog)
renoise.song().transport.playing_observable:add_notifier(check_closed)
renoise.song().patterns[pattern_index_holder]:add_line_notifier(line_has_changed)
   
------------------------------------------------------------------------------ 
-- oprint(renoise.tool())
   

end  --main

-------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------

   renoise.tool():add_keybinding {
  name = "Global:Tools:TickyRoll",
  invoke = function()render_notes()end
}



--Adds too much latency:  
               
--[[renoise.tool():add_timer(function()
   
                   refresh_happening = false
                  ----------------------------------------------------------------------------------
                  -- 4th. Get Notes From Track 
                  ----------------------------------------------------------------------------------

                  --iterate the selected track line iteration {}
                  iterator_get_notes(number_of_ticky_rows,pattern_index,track_index,chosen_line_range,iteration,iter_incrementor,pattern_iter)
                  --fill pattern_notes {}
                  my_fill_pattern_notes_table(pattern_notes,iteration,number_of_ticky_rows,first_c)

                  ---------------------------------------------------------------------------------


                  --reset vb:views checkbox id`s
                  for row = 1,number_of_ticky_rows do
   
                    for i  = first_c,top_c do
                
                      refresh_happening = true --stops checkbox notifier re-firing
                      vb.views[row.."cb_"..i].value = pattern_notes[row].row_notes[i]
                      refresh_happening = false --then reset
                    end       
                  end
                  --iterate the selected track line iteration {}
                  iterator_get_notes(number_of_ticky_rows,pattern_index,track_index,chosen_line_range,iteration,iter_incrementor,pattern_iter)
                  --fill pattern_notes {}
                  my_fill_pattern_notes_table(pattern_notes,iteration,number_of_ticky_rows,first_c)  
      
                 end, 
  500) --]]                
         
--renoise.song().transport.playing_observable:remove_notifier(refresh_when_play)   


  --if (my_dialog and my_dialog.visible) then <-- only allows one dialog instance
  --  my_dialog:show()
  --  return
  --  end
  

